unit Childwin;

interface

uses Windows, Classes, Graphics, Forms, Controls, UCWReport, ComCtrls,
  ExtCtrls, StdCtrls, Buttons, SysUtils, Handles, CWWinProcs, Messages,
  Menus, UDBForm, DBCtrls, DB, DBTables,Dialogs;

type
  TMDIChild = class(TForm)
    CWWinProcs1: TCWWinProcs;
    CWReport: TCWReport;
    Panel1: TPanel;
    TabControl: TTabControl;
    NavPanel: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    PageCount: TEdit;
    PopupMenu1: TPopupMenu;
    NewPage1: TMenuItem;
    N2: TMenuItem;
    DeletePage1: TMenuItem;
    N3: TMenuItem;
    NextPage1: TMenuItem;
    PriviousPage1: TMenuItem;
    PMCtrlChange: TPopupMenu;
    DBMemoItem: TMenuItem;
    DBImageItem: TMenuItem;
    DBEditItem: TMenuItem;
    N4: TMenuItem;
    BandOptionsItem: TMenuItem;
    N5: TMenuItem;
    DeleteItem: TMenuItem;
    N1: TMenuItem;
    FontItem: TMenuItem;
    ColorItem: TMenuItem;
    N6: TMenuItem;
    EditItem: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TabControlChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CWReportMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure NewPage1Click(Sender: TObject);
    procedure DeletePage1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure NextPage1Click(Sender: TObject);
    procedure PriviousPage1Click(Sender: TObject);
    procedure CWReportDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure CWReportDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PMCtrlChangePopup(Sender: TObject);
    procedure DBMemoItemClick(Sender: TObject);
    procedure BandOptionsItemClick(Sender: TObject);
    procedure DeleteItemClick(Sender: TObject);
    procedure CWReportReportPageRefresh(Sender: TCustomReportPage);
    procedure CWReportPageChanged(Sender: TObject);
    procedure FontItemClick(Sender: TObject);
    procedure ColorItemClick(Sender: TObject);
    procedure EditItemClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CWWinProcs1Delete(Sender: TControl; var Message: TMessage;
      var Action: Boolean);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure CWWinProcs1AfterMsg(Sender: TControl; var Message: TMessage);
  private
    { Private declarations }
  public
    { Public declarations }
   Handles: TStretchHandles;
   Attaching: Boolean;
   Modified: Boolean;
   procedure EditDatasets;
   procedure UniqueName(Comp: TComponent; AName: String);
   function GetDatasource(Query: TQuery): TDatasource;
  end;

implementation

uses Main, UBandOpt, UEditText;

{$R *.DFM}


procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Handles.Detach;
  Handles.OnMouseUp := Nil;
  Handles.free;
  Handles := Nil;
  Action := caFree;
end;

procedure TMDIChild.TabControlChange(Sender: TObject);
begin
     CWReport.SwitchOn := TabControl.TabIndex = 0;
      InvalidateRect(CWReport.ActiveReportPage.Handle,Nil,true);
end;

procedure TMDIChild.EditDatasets;
begin
 Edit(Self);
end;

procedure TMDIChild.UniqueName(Comp: TComponent; AName: String);
var I: Integer;
begin

 if (Trim(AName) = '') or not(IsValidIdent(AName)) then
 AName := Copy(Comp.Classname,2,Length(Comp.Classname));

 I := 1;

 while True do
 begin
  try
   Comp.Name := AName + Inttostr(I);
  except
   I := I + 1;
   continue;
  end;
 break;
 end;

end;

procedure TMDIChild.SpeedButton1Click(Sender: TObject);
begin
CWReport.PageIndex := 1;
end;

procedure TMDIChild.SpeedButton4Click(Sender: TObject);
begin
CWReport.PageIndex := CWReport.PageCount;
end;

procedure TMDIChild.SpeedButton2Click(Sender: TObject);
begin
CWReport.PageIndex := CWReport.PageIndex - 1
end;

procedure TMDIChild.SpeedButton3Click(Sender: TObject);
begin
CWReport.PageIndex := CWReport.PageIndex + 1
end;

procedure TMDIChild.CWReportMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var Pnt: TPoint;
    APage: TWinControl;
    Band: TCWBand;
    Text: TStaticText;
    I: Integer;
begin
       if (MainForm.BandBtn.Down) and (Sender is TCWReport) then
       begin
        APage := CWReport.ActiveReportPage;
        Band := TCWBand.create(Self);
        with Band do
         begin
          Parent := APage;
          Pnt := Point(X,Y);
          Pnt := APage.ScreenToClient(Self.ClientToScreen(Pnt));
          Top := Pnt.Y;
          Left := Pnt.X;
          PopUpMenu := PMCtrlChange;
          Tag := 10;
          MainForm.ArrowBtn.click;
          MainForm.ArrowBtn.Down := true;
          OnDragOver := CWReportDragOver;
          OnDragDrop := CWReportDragDrop;
          OnMouseDown := CWReportMouseDown;
         end;
        UniqueName(Band,BandTypeToString(Band.BandType));
        BandEdit(Band);
       end;

       if MainForm.TextBtn.Down then
       begin
        if Sender is TCWReport then
        APage := CWReport.ActiveReportPage else
        APage := TCWBand(Sender);
        Text := TStaticText.create(Self);
        with Text do
         begin
          UniqueName(Text,Text.classname);
          Pnt := Point(X,Y);
          if Sender is TCWReport then
          Pnt := APage.ScreenToClient(Self.ClientToScreen(Pnt));
          Parent := APage;
          Top := Pnt.Y;
          Left := Pnt.X;
          PopUpMenu := PMCtrlChange;
          Tag := 10;
          MainForm.ArrowBtn.click;
          MainForm.ArrowBtn.Down := true;
          PMCtrlChange.PopUpComponent := Text;
          EditItemClick(PMCtrlChange);
         end;
       end;

end;

procedure TMDIChild.FormCreate(Sender: TObject);
begin
 Handles := TStretchHandles.create(Nil);
 Handles.OnMouseUp := FormMouseUp;
 Modified := true;
end;

function TMDIChild.GetDatasource(Query: TQuery): TDatasource;
var I: Integer;
begin
 Result := Nil;
 for I := 0 to ComponentCount - 1 do
  if ( Components[I] is TDatasource ) and
     (TDatasource(Components[I]).Dataset = Query) then
     begin
      Result := TDatasource(Components[I]);
      exit;
     end;
end;



procedure TMDIChild.NewPage1Click(Sender: TObject);
begin
CWReport.ReportPageColl.AddPage;
end;

procedure TMDIChild.DeletePage1Click(Sender: TObject);
var Comp: TComponent;
    I: Integer;
begin
CWReport.StrPages.Delete(CWReport.ReportPageIndex);
end;

procedure TMDIChild.PopupMenu1Popup(Sender: TObject);
begin
DeletePage1.Enabled := CWReport.ReportPageIndex > 0;
NextPage1.Enabled := CWReport.ReportPageIndex < CWReport.ReportPageCount - 1;
PriviousPage1.Enabled := CWReport.ReportPageIndex > 0;
end;

procedure TMDIChild.NextPage1Click(Sender: TObject);
begin
CWReport.ReportPageIndex := CWReport.ReportPageIndex + 1
end;

procedure TMDIChild.PriviousPage1Click(Sender: TObject);
begin
CWReport.ReportPageIndex := CWReport.ReportPageIndex - 1
end;

procedure TMDIChild.CWReportDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := true;
end;

procedure TMDIChild.CWReportDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var Title: TStaticText;
    DBField: TDBEdit;
    Prnt: TWinControl;
begin
 if Source is TListBox then
  begin
   if Sender is TCWReport then
    Prnt := TCWReport(Sender).ActiveReportPage else
    Prnt := TWinControl(Sender);
   Title := TStaticText.Create(self);
   Title.Parent := Prnt;
   DBField := TDBEdit.create(Self);
   DBField.Borderstyle := bsNone;
   DBField.AutoSize := False;
   DBField.Parent := Title.Parent;
   Title.Caption := TListBox(Source).Items[TListBox(Source).ItemIndex];
   Title.Color := clWhite;
   DBField.DataSource :=  GetDatasource(TQuery(TListBox(Source).Items.Objects[TListBox(Source).ItemIndex]));
   if DBField.Datasource = Nil then
   begin
    DBField.Free;
    Title.Free;
    ShowMessage('Can not find Datasource !');
    exit;
   end;
   DBField.DataField := Title.Caption;
   Title.Top := Y;
   Title.Left := X;
   DBField.Top := Y;
   DBField.Left := X + Title.Width + 10;
   DBField.Tag := 10;
   Title.Tag := 10;
   DBField.ReadOnly := true;
   DBField.PopupMenu := PMCtrlChange;
   Title.PopupMenu := PMCtrlChange;

   if not DBField.DataSource.Dataset.Active then
      DBField.DataSource.Dataset.Open;

  end;
end;

procedure TMDIChild.PMCtrlChangePopup(Sender: TObject);
begin

     if Handles.Attached then Handles.Detach;

     FontItem.Enabled        := true;
     ColorItem.Enabled       := true;
     EditItem.Enabled        := PMCtrlChange.PopupComponent is TStaticText;
     DBEditItem.Enabled      := false;
     DBMemoItem.Enabled      := false;
     DBImageItem.Enabled     := false;
     BandOptionsItem.Enabled := false;
     DeleteItem.Enabled      := true;

 if PMCtrlChange.PopupComponent is TDBEdit then
    begin
     FontItem.Enabled        := true;
     ColorItem.Enabled       := true;
     EditItem.Enabled        := false;
     DBEditItem.Enabled      := false;
     DBMemoItem.Enabled      := true;
     DBImageItem.Enabled     := true;
     BandOptionsItem.Enabled := false;
     DeleteItem.Enabled      := true;
    end;
 if PMCtrlChange.PopupComponent is TDBMemo then
    begin
     FontItem.Enabled        := true;
     ColorItem.Enabled       := true;
     EditItem.Enabled        := false;
     DBEditItem.Enabled      := true;
     DBMemoItem.Enabled      := false;
     DBImageItem.Enabled     := true;
     BandOptionsItem.Enabled := false;
     DeleteItem.Enabled      := true;
    end;
 if PMCtrlChange.PopupComponent is TDBImage then
    begin
     FontItem.Enabled        := true;
     ColorItem.Enabled       := true;
     EditItem.Enabled        := false;
     DBEditItem.Enabled      := true;
     DBMemoItem.Enabled      := true;
     DBImageItem.Enabled     := false;
     BandOptionsItem.Enabled := false;
     DeleteItem.Enabled      := true;
    end;
 if PMCtrlChange.PopupComponent is TCWBand then
    begin
     FontItem.Enabled        := false;
     ColorItem.Enabled       := true;
     EditItem.Enabled        := false;
     DBEditItem.Enabled      := false;
     DBMemoItem.Enabled      := false;
     DBImageItem.Enabled     := false;
     BandOptionsItem.Enabled := true;
     DeleteItem.Enabled      := true;
    end;
end;

procedure TMDIChild.DBMemoItemClick(Sender: TObject);
var DBM: TDBMemo;
    DBI: TDBImage;
    DBE: TDBEdit;
    WC: TWinControl;
    DC: TDatasource;
    DF: String;
    Pos: TPoint;
    Prnt: TWinControl;
begin

    WC := TWinControl(PMCtrlChange.PopupComponent);
    Prnt := WC.Parent;
    Pos := WC.BoundsRect.TopLeft;
    if WC is TDBImage then
          begin
          DC := TDBImage(WC).Datasource;
          DF := TDBImage(WC).DataField;
          end;
    if WC is TDBEdit then
          begin
          DC := TDBEdit(WC).Datasource;
          DF := TDBEdit(WC).DataField;
          end;
    if WC is TDBMemo then
          begin
          DC := TDBMemo(WC).Datasource;
          DF := TDBMemo(WC).DataField;
          end;



    case TComponent(Sender).Tag of
     0: begin
         DBM := TDBMemo.Create(Self);
         DBM.Parent := Prnt;
         DBM.Datasource := DC;
         DBM.DataField := DF;
         DBM.BoundsRect := Bounds(Pos.x, Pos.y, DBM.Width, DBM.Height);
         DBM.PopupMenu := PMCtrlChange;
         DBM.ReadOnly := true;
         DBM.BorderStyle := bsNone;
         DBM.Tag := 10;
         UniqueName(DBM,DBM.classname);
        end;

     1: begin
         DBI := TDBImage.create(self);
         DBI.Parent := Prnt;
         DBI.Datasource := DC;
         DBI.DataField := DF;
         DBI.BoundsRect := Bounds(Pos.x, Pos.y, DBI.Width, DBI.Height);
         DBI.PopupMenu := PMCtrlChange;
         DBI.ReadOnly := true;
         DBI.BorderStyle := bsNone;
         DBI.Tag := 10;
         DBI.Stretch := true;
         UniqueName(DBI,DBI.classname);
        end;
     2: begin
         DBE := TDBEdit.Create(Self);
         DBE.Parent := Prnt;
         DBE.Datasource := DC;
         DBE.DataField := DF;
         DBE.BoundsRect := Bounds(Pos.x, Pos.y, DBE.Width, DBE.Height);
         DBE.PopupMenu := PMCtrlChange;
         DBE.ReadOnly := true;
         DBE.BorderStyle := bsNone;
         DBE.Tag := 10;
         UniqueName(DBE,DBE.classname);
        end;

    end;

    WC.Free;

end;

procedure TMDIChild.BandOptionsItemClick(Sender: TObject);
begin
   BandEdit(TCWBand(PMCtrlChange.PopupComponent));
end;

procedure TMDIChild.DeleteItemClick(Sender: TObject);
begin
Handles.Detach;
if Assigned(PMCtrlChange) then
  PMCtrlChange.PopupComponent.Free;
CWReport.ActiveReportPage.Invalidate;
end;

procedure TMDIChild.CWReportReportPageRefresh(Sender: TCustomReportPage);
begin
PageCount.Text := 'Page : '+ inttostr(CWReport.PageIndex)+ ' of ' +
                             inttostr(CWReport.PageCount);
end;

procedure TMDIChild.CWReportPageChanged(Sender: TObject);
begin
CWReportReportPageRefresh(nil);
MainForm.StatusBar.SimpleText := 'Current ReportPage : '+ inttostr(CWReport.ReportPageIndex + 1);
end;

procedure TMDIChild.FontItemClick(Sender: TObject);
var Comp: TComponent;
begin

      Comp := PMCtrlChange.PopUpComponent ;

      if Assigned(Comp) then
       begin
       if Comp is TDBEdit then
        MainForm.FontDialog.Font.Assign(TDBEdit(Comp).Font);

       if Comp is TDBMemo then
        MainForm.FontDialog.Font.Assign(TDBMemo(Comp).Font);

       if Comp is TStaticText then
        MainForm.FontDialog.Font.Assign(TStaticText(Comp).Font);
       end;

      if MainForm.FontDialog.execute then
      begin

       if Comp is TDBEdit then
        TDBEdit(Comp).Font.Assign(MainForm.FontDialog.Font);

       if Comp is TDBMemo then
        TDBMemo(Comp).Font.Assign(MainForm.FontDialog.Font);

       if Comp is TStaticText then
        TStaticText(Comp).Font.Assign(MainForm.FontDialog.Font);

     end;
end;

procedure TMDIChild.ColorItemClick(Sender: TObject);
var Comp: TComponent;
begin

      Comp := PMCtrlChange.PopUpComponent ;

      if Assigned(Comp) then
      begin

       if Comp is TDBEdit then
        MainForm.ColorDialog.Color := TDBEdit(Comp).Color;

       if Comp is TDBMemo then
        MainForm.ColorDialog.Color := TDBMemo(Comp).Color;

       if Comp is TStaticText then
        MainForm.ColorDialog.Color := TStaticText(Comp).Color;

       if Comp is TCWBand then
        MainForm.ColorDialog.Color := TCWBand(Comp).Brush.Color;

      end;



      if MainForm.ColorDialog.execute then
      begin

       if Comp is TDBEdit then
        TDBEdit(Comp).Color := MainForm.ColorDialog.Color;

       if Comp is TDBMemo then
        TDBMemo(Comp).Color := MainForm.ColorDialog.Color;

       if Comp is TStaticText then
        TStaticText(Comp).Color := MainForm.ColorDialog.Color;

       if Comp is TCWBand then
        TCWBand(Comp).Brush.Color := MainForm.ColorDialog.Color;

     end;
end;

procedure TMDIChild.EditItemClick(Sender: TObject);
begin
if PMCtrlChange.PopUpComponent is TStaticText then
EditText(TStaticText(PMCtrlChange.PopUpComponent));
end;

procedure TMDIChild.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if Modified then
 case MessageDlg('Save changes of '+ Caption +' ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
  mrCancel: CanClose := false;
  mrNo: { nothing }  ;
  mrYes:
   begin
    if not FileExists(Caption) then
     begin
      MainForm.FileSaveAsItemClick(Self);
      CanClose := FileExists(Caption); // Abort in Saveas ?
     end else
      MainForm.FileSaveItemClick(Self);
   end;
  end;
end;

procedure TMDIChild.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//MainForm.RefreshBtnClick(Sender);
end;

procedure TMDIChild.CWWinProcs1Delete(Sender: TControl;
  var Message: TMessage; var Action: Boolean);
begin
if Assigned(Handles) and (Handles.Indexof(Sender) > -1) then
   Handles.ReleaseChild(Sender);
end;

procedure TMDIChild.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var Pt: TPoint;
    Msg: TWMMouse;
    Band: TCWBand;
begin
Pt := Point(X,Y);
Msg.Pos := PointtoSmallPoint(Pt);
Msg.Msg := 0;
Msg.Keys := 0;
Accept := CWReport.ActiveReportPage.SetBandPos(Msg);
end;


procedure TMDIChild.CWWinProcs1AfterMsg(Sender: TControl;
  var Message: TMessage);
var Page: TCustomReportPage;
      IsUpdate:Boolean;
begin

if (csDestroying in ComponentState) or (csLoading in ComponentState) then exit;

 if (Message.Msg = WM_RButtonDown) and Handles.Attached then
 Handles.Detach;
if not(Assigned(Sender)) or Attaching or (Sender is TStretchHandles) then exit;
if (Message.Msg = WM_LBUTTONDOWN) then
 if (Sender.Tag = 10) then
  begin
    Page := CWReport.ActiveReportPage;
    If Handles.IndexOf(Sender) > 0 then exit;
    Attaching := true;
    IsUpdate := Page.AUpdating;
    if IsUpdate then Page.AUpdating := false;
    Handles.Detach;
    Handles.Attach(Sender);
    if Handles.ChildCount > 0 then
       MainForm.StatusBar.SimpleText := 'Attaching '+
                                         Handles.Children[0].Classname+' Name = '+
                                         Handles.Children[0].name;
    if IsUpdate then Page.AUpdating := true;
    Attaching := false;
  end else
   if Assigned(Handles) and Handles.Attached then
   begin
    Page := CWReport.ActiveReportPage;
    IsUpdate := Page.AUpdating;
    if IsUpdate then Page.AUpdating := false;
    Handles.Detach;
    if IsUpdate then Page.AUpdating := true;
   end;
end;

end.
