unit UBandOpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, UCWReport, DB, Menus;

type
  TFmBandOpt = class(TForm)
    rgBandType: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    SpCol: TSpinEdit;
    SpColsp: TSpinEdit;
    Label3: TLabel;
    SpRows: TSpinEdit;
    Label4: TLabel;
    SpRowsp: TSpinEdit;
    Label5: TLabel;
    SpShadow: TSpinEdit;
    Label6: TLabel;
    SpCurve: TSpinEdit;
    GroupBox2: TGroupBox;
    CbDataset: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    SpCopies: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    CBParent: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    MGroup: TMemo;
    PopupMenu1: TPopupMenu;
    Edit1: TMenuItem;
    Label12: TLabel;
    Bevel1: TBevel;
    ColorDialog: TColorDialog;
    rbJump: TCheckBox;
    rbAfter: TCheckBox;
    rbBefore: TCheckBox;
    rbRounded: TCheckBox;
    cbPenColor: TEdit;
    cbShColor: TEdit;
    procedure Edit1Click(Sender: TObject);
    procedure cbPenColorDblClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   ABand: TCWBand;
   procedure Init(Band: TCWBand);
   procedure Apply(Band: TCWBand);
  end;

  procedure BandEdit(Band: TCWBand);

var
  FmBandOpt: TFmBandOpt;

implementation

uses QRExpbld;

{$R *.DFM}

procedure BandEdit(Band: TCWBand);
var Form: TFMBandOpt;
begin
    Form := TFMBandOpt.create(Nil);
    try
     Form.Init(Band);
     if Form.ShowModal = mrOK then
        Form.Apply(Band);
    finally
    Form.Free;
    end;
end;

procedure TFmBandOpt.Init(Band: TCWBand);
var AForm: TCOmponent;
    I: Integer;
begin

  ABand := Band;

  CBDataset.Items.clear;
  CBParent.Items.Clear;

  AForm := GetParentForm(Band);
  for I := 0 to AForm.ComponentCount - 1 do
   if AForm.Components[I] is TDataset then
    CBDataset.Items.Add(TDataset(AForm.Components[I]).Name);
    CBDataset.Items.Add(' ');

  for I := 0 to AForm.ComponentCount - 1 do
   if (AForm.Components[I] is TCWBand) and
      (AForm.Components[I] <> Band)then
    CBParent.Items.Add(TDataset(AForm.Components[I]).Name);
    CBParent.Items.Add(' ');



  with Band do
   begin
    SPCol.Value := Columns;
    SPColsp.Value := Columnspace;
    SPRowSp.Value := RowSpace;
    SPShadow.Value := ShadowWidth;
    SPCurve.value := Curve;
    if Assigned(Dataset) then
     CBDataset.ItemIndex := CBDataset.Items.Indexof(Dataset.Name);
    SPCopies.Value := Copies;
    if Assigned(ParentBand) then
     CBParent.ItemIndex := CBParent.Items.Indexof(ParentBand.Name);
    MGroup.Text := GroupByExpr;
    CBSHColor.Text := ColorToString(ShadowBrush.Color);
    CBPenColor.Text := ColorToString(Pen.color);
    rgBandType.ItemIndex := Integer(BandType);
    rbRounded.Checked := Rounded;
    rbJump.Checked := Jump;
    rbAfter.Checked := NewPageAfter;
    rbBefore.Checked := NewPageBefore;
   end;
end;

procedure TFmBandOpt.Apply(Band: TCWBand);
var AForm: TCustomForm;
    Comp: TComponent;
begin
 with Band do
   begin
    Columns := SPCol.Value ;
    Columnspace := SPColsp.Value;
    RowSpace := SPRowSp.Value;
    ShadowWidth := SPShadow.Value;
    Curve := SPCurve.value;
    Copies := SPCopies.Value;
    GroupByExpr := MGroup.Text;
    ShadowBrush.Color := StringtoColor(CBSHColor.Text);
    Pen.color := StringtoColor(CBPenColor.Text);
    BandType := TBandType(rgBandType.ItemIndex);
    Rounded := rbRounded.Checked;
    Jump := rbJump.Checked;
    NewPageAfter := rbAfter.Checked;
    NewPageBefore := rbBefore.Checked;


    if CBDataset.Text <> '' then
    begin
     AForm := GetParentForm(Band);
     if Assigned(AForm) then
      begin
       Comp := AForm.FindComponent(CBDataset.Text);
       if Comp is TDataset then
        Dataset := TDataset(Comp) else Dataset := Nil;
      end;
    end;

    if CBParent.Text <> '' then
    begin
     AForm := GetParentForm(Band);
     if Assigned(AForm) then
      begin
       Comp := AForm.FindComponent(CBParent.Text);
       if Comp is TCWBand then
        ParentBand := TCWBand(Comp) else ParentBand := Nil;
      end;
    end;


   end;
end;

procedure TFmBandOpt.Edit1Click(Sender: TObject);
var AValue: String;
begin
AValue := MGroup.Text;
if GetExpression('Edit Groupbyexpression',AValue,TForm(GetParentForm(ABand))) then
MGroup.Text := AValue;
end;

procedure TFmBandOpt.cbPenColorDblClick(Sender: TObject);
begin
if ColorDialog.Execute then
   TComboBox(Sender).Text := ColorToString(ColorDialog.Color);
end;

end.
