unit UDBForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DBTables, StdCtrls, ExtCtrls, Menus, db;

type
  TDBForm = class(TForm)
    DBTV: TTreeView;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    GrSql: TGroupBox;
    GrFilter: TGroupBox;
    Panel2: TPanel;
    MSql: TMemo;
    Panel3: TPanel;
    MFilter: TMemo;
    PopupMenu1: TPopupMenu;
    New1: TMenuItem;
    N1: TMenuItem;
    Delete1: TMenuItem;
    Panel4: TPanel;
    Label1: TLabel;
    CBDatasets: TComboBox;
    procedure DBTVChange(Sender: TObject; Node: TTreeNode);
    procedure MSqlChange(Sender: TObject);
    procedure DBTVChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure MFilterChange(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CBDatasetsChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   ChildForm: TComponent;
   procedure CreateQuery(Database,Tablename,Alias: String);
   procedure MakeTree;
   function  GetDatasource(AName: String): TDatasource;
   procedure SetDatasource(DS: TDatasource);
   procedure SetQueryDatasource(Q: TQuery;AName: String);
  end;

  procedure Edit(AComp: TComponent);

var
  DBForm: TDBForm;

implementation

uses UDBSelect;

{$R *.DFM}

procedure Edit(AComp: TComponent);
var F: TDBForm;
begin
 F := TDBForm.Create(Nil);
 with F do
 try
  ChildForm := AComp;
  MakeTree;
  F.SHowModal;
 finally
 F.Free;
 end;
end;

function TDBForm.GetDatasource(AName: String): TDatasource;
begin
 if ChildForm.FindComponent(AName) is TDatasource then
  Result := TDatasource(ChildForm.FindComponent(AName)) else
  Result := Nil;
end;

procedure TDBForm.SetDatasource(DS: TDatasource);
var Index: Integer;
begin
 if Assigned(DS) then
  begin
  Index := CBDatasets.Items.Indexof(Copy(DS.Name,2,10000));
  if Index > -1 then
   CBDatasets.ItemIndex := Index else
   CBDatasets.ItemIndex := CBDatasets.Items.Indexof(' ');
  end else CBDatasets.ItemIndex := CBDatasets.Items.Indexof(' ');
end;

procedure TDBForm.SetQueryDatasource(Q: TQuery;AName: String);
begin
      if Assigned(Q) then
      Q.Datasource := GetDatasource(AName);
end;

procedure TDBForm.MakeTree;
var Node: TTreeNode;
    I: Integer;
begin

  CBDatasets.Items.Clear;

  for I := 0 to ChildForm.ComponentCount - 1 do
   if ChildForm.Components[I] is TDataSource then
    CBDatasets.Items.Add(Copy(TDataSource(ChildForm.Components[I]).Name,2,10000));
    CBDatasets.Items.Add(' ');


 DBTV.Items.Clear;

 Node := DBTV.Items.Add(Nil, 'Querys');

 for I := 0 to ChildForm.ComponentCount - 1 do
 if ChildForm.Components[I] is TQuery then
 begin
  with DBTV.Items.AddChild(Node,ChildForm.Components[I].Name) do
   Data := ChildForm.Components[I];
 end;
 DBTV.AlphaSort;

end;



procedure TDBForm.DBTVChange(Sender: TObject; Node: TTreeNode);
begin
if Assigned(Node.Data) and (TComponent(Node.Data) is TQuery) then
 begin
  MSql.Lines.Assign(TQuery(Node.Data).Sql);
  MFilter.Text := TQuery(Node.Data).Filter;
  SetDatasource(TQuery(Node.Data).Datasource);
  CBDatasets.Tag := 0;
  MSql.Tag := 0;
  MFilter.Tag := 0;
  CBDatasets.Enabled := true;
  MSql.Enabled := true;
  MFilter.Enabled := true;
 end else
 begin
  MSql.Enabled := false;
  MFilter.Enabled := false;
  CBDatasets.Enabled := false;
 end;
end;

procedure TDBForm.MSqlChange(Sender: TObject);
begin
MSql.Tag := 1;
end;

procedure TDBForm.DBTVChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
   Node := DBTV.Selected;
if (Msql.Tag = 1) or (MFilter.Tag = 1) or (CBDatasets.Tag = 1) then
  case MessageDlg('Apply Sql Changes ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
   mrNo: begin
          Msql.Tag := 0;
          MFilter.Tag := 0;
          CBDatasets.Tag := 0;
         end;
   mrYes: begin
           TQuery(Node.Data).close;
           TQuery(Node.Data).Sql.Assign(MSql.Lines);
           MSql.Tag := 0;

           TQuery(Node.Data).Filter := MFilter.Text;
           MFilter.Tag := 0;

           SetQueryDatasource(TQuery(Node.Data),'D'+CBDatasets.Text);
           CBDatasets.Tag := 0;

          end;
   mrCancel: begin
              AllowChange := false;
              MSql.SetFocus;
              exit;
             end;
   end;
end;

procedure TDBForm.MFilterChange(Sender: TObject);
begin
MFilter.Tag := 1;
end;

procedure TDBForm.PopupMenu1Popup(Sender: TObject);
begin
  New1.Enabled := Assigned(DBTV.Selected) and
                          (DBTV.Selected.Text = 'Querys');
  Delete1.Enabled := Assigned(DBTV.Selected) and
                     Assigned(DBTV.Selected.Data) and
                     (TComponent(DBTV.Selected.Data) is TQuery);
end;

procedure TDBForm.New1Click(Sender: TObject);
begin
    with TDBSelect.Create(ChildForm) do
    try
     if ShowModal = mrOK then
       CreateQuery(DBList.Items[DBList.ItemIndex],DBTablesList.Items[DBTablesList.ItemIndex],EAlias.Text);
       MakeTree;
       DBTV.Items[0].Expand(true);
    finally
    free;
    end;

end;

procedure TDBForm.CreateQuery(Database,Tablename,Alias: String);
var Query: TQuery;
    Datasource: TDatasource;
begin
    if (TableName = '') or (Database = '') then exit;
    Query := TQuery.create(ChildForm);
    Query.Name := Alias;
    Query.Filtered := true;
    Datasource := TDatasource.create(ChildForm);
    Datasource.Name := 'D'+Alias;
    Datasource.Dataset := Query;
    Query.DataBasename := DataBase;
    Query.Sql.Add('Select * from ' + TableName);
end;


procedure TDBForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if (Msql.Tag = 1) or (MFilter.Tag = 1) or (CBDatasets.Tag = 1) then
 DBTVChanging(Sender, DBTV.Selected,CanClose)
end;

procedure TDBForm.CBDatasetsChange(Sender: TObject);
begin
CBDatasets.Tag := 1;
end;

end.
