unit UDBSelect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, dBTables;

type
  TDbSelect = class(TForm)
    Panel1: TPanel;
    OKBtn: TButton;
    Button2: TButton;
    DBList: TListBox;
    DBTablesList: TListBox;
    Label1: TLabel;
    EAlias: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure DBListClick(Sender: TObject);
    procedure DBTablesListClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   ACanClose: Boolean;
  end;

var
  DbSelect: TDbSelect;

implementation

uses Consts;

{$R *.DFM}

procedure TDbSelect.FormCreate(Sender: TObject);
begin
Session.GetDatabaseNames(DBList.Items);
end;

procedure TDbSelect.DBListClick(Sender: TObject);
begin
Session.GetTableNames(DBList.Items[DBList.ItemIndex],'',true,true,DBTablesLIst.Items);
OKBtn.enabled := false;
end;

procedure TDbSelect.DBTablesListClick(Sender: TObject);
var A: String;
begin
OKBtn.enabled := (DBTablesList.ItemIndex > -1) and (DBList.ItemIndex > -1);
if not OKBtn.enabled then exit;
A := DBTablesList.Items[DBTablesList.ItemIndex];
if Pos('.',A) > 0 then A := Copy(A,1,Pos('.',A) - 1);
if Pos('.',A) > 0 then A := Copy(A,Pos('.',A)+ 1,Length(A));
EAlias.Text := A;
end;

procedure TDbSelect.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin

  if ModalResult <> mrOk then exit;

  if Assigned(TForm(Owner).FindComponent(EAlias.text)) then
 begin
  ShowMessage('This alias already exists !');
  CanClose := false;
 end;

 if Trim(EAlias.text) = '' then
  begin
  ShowMessage('No alias !');
  CanClose := false;
 end;

 if not IsValidIdent(EAlias.Text) then
 begin
  CanClose := false;
  raise EComponentError.CreateFmt(SInvalidName, [EAlias.Text]);
 end;

end;

end.
