unit UEditText;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFMEditText = class(TForm)
    Label1: TLabel;
    EdText: TEdit;
    Bevel1: TBevel;
    Label2: TLabel;
    EdDynText: TEdit;
    EvalBtn: TButton;
    Label3: TLabel;
    CbBand: TComboBox;
    Bevel2: TBevel;
    Button2: TButton;
    Button3: TButton;
    cbAggreg: TCheckBox;
    procedure EvalBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
   AControl: TControl;
  end;

  procedure EditText(AComp: TStaticText);

var
  FMEditText: TFMEditText;

implementation

uses UCWReport, QRExpbld;

{$R *.DFM}


procedure EditText(AComp: TStaticText);
var I: Integer;
    AForm: TCustomReportPage;
    Eval: TEvalCollectionItem;
    NewBand: TCWBand;


          function FindBand(CBand: String): TCWBand;
          var m: Integer;
          begin
           Result := Nil;
           if Assigned(AForm) then
            for m := 0 to AForm.BandCount - 1 do
             if AForm.Bands[m].Name = CBand then
              begin
               Result := AForm.Bands[m];
               exit;
              end;
          end;


begin


  with TFMEditText.create(Nil) do
  try
   EdText.Text := AComp.Caption;
   AControl := AComp;

   if AComp.Parent is TCustomReportPage then
    AForm := TCustomReportPage(AComp.Parent) else
    AForm := TCustomReportPage(TCWBand(AComp.Parent).Parent);
   for I := 0 to AForm.BandCount - 1 do
     CBBand.Items.Add(AForm.Bands[I].Name);

   Eval := GetEvaluationItem(AComp);
   if Assigned(Eval) then
    begin
     EdText.Text := '';
     EdDynText.Text := Eval.Expression;
     CBBand.Text := TEvalCollection(Eval.Collection).Band.Name;
     CBAggreg.Checked := Eval.Aggreg;
    end;

   if ShowModal = mrOk then
   begin

    if Trim(EdText.Text) <> '' then AComp.Caption := EdText.Text else
    begin
     if Assigned(Eval) then
      begin
       NewBand := FindBand(CBBand.Text);
       if Assigned(NewBand) then
        if (NewBand <> TEvalCollection(Eval).Band) then  // Create and Delete
        begin
         with NewBand.Evaluations.Add do  //create
          begin
           Expression := EdDynText.Text;
           Control := AComp;
           Aggreg := CBAggreg.Checked;
          end;
         Eval.Free;
        end else
       Eval.Expression := EdDynText.Text;
      end else
      begin
       NewBand := FindBand(CBBand.Text);
       if Assigned(NewBand) then
       with NewBand.Evaluations.Add do  //create
          begin
           Expression := EdDynText.Text;
           Control := AComp;
           Aggreg := CBAggreg.Checked;
          end;
      end;
     end;
   end;
  finally
  Free;
  end;
end;

procedure TFMEditText.EvalBtnClick(Sender: TObject);
var AValue: String;
begin
AValue := EdDynText.Text;
if GetExpression('Edit Groupbyexpression',AValue,TForm(GetParentForm(AControl))) then
EdDynText.Text := AValue;
end;

end.
